# Copyright (C) 2008, Polychronis Ypodimatopoulos
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


import sys, re, os

PREFIX = "10"

def get_Wireless_Iface():
	p = os.popen("cat /proc/net/wireless")
	t = p.read()
	p.close()
	try:
		res = re.search("(\S+):",t).group(1)
	except:
		print "No wireless interface found!"
		res = ""
	return res

def get_all_wireless():
	res = []
	p = os.popen("cat /proc/net/wireless|grep :|cut -d':' -f1")
	for iface in p:
		res.append(iface[2:].strip())
	return res
	
	
def get_IP(iface):
	p=os.popen("/sbin/ifconfig %s" % iface)
	t=p.read()
	p.close()
	res = re.search("inet addr:([0-9a-fA-F\.]+)",t)
	if res: return res.group(1)
	else: return ""

def get_MAC(wface, as_str=0):
	p = os.popen("cat /sys/class/net/%s/address" % wface)
	res = p.read().strip()
	if len(res) == 0:
		print "Interface", wface, "not found!"
		sys.exit()
	p.close()
	if as_str:
		return res
	else:
		return ''.join([chr(int(x, 16)) for x in res.split(':')])

def calc_IP(iface=""):
	if len(iface) == 0:
		iface = get_Wireless_Iface()

	mac = get_MAC(iface, as_str=1)
	#print "mac",mac
	mac = re.split(':', mac)
	
	c1 = str(int(mac[3], 16))
	c2 = str(int(mac[4], 16))
	c3 = str(int(mac[5], 16))
	
	ip 		= "%s.%s.%s.%s" % (PREFIX, c1, c2, c3)
	command = "ip a add %s/8 brd + dev %s" % (ip, iface)
	p 		= os.popen(command).read()
	return ip
	
if __name__ == "__main__":
	for i in get_all_wireless():
		print i
		if i[0] == 'a':
			print calc_IP(i)
			
			sys.exit()
	
	sys.exit()
	if len(sys.argv) > 1:
		iface = sys.argv[1]
		calc_IP(iface)
	else:
		calc_IP()
